//----------------------------------------------------------------------------

// ,  

//----------------------------------------------------------------------------

#ifndef MAIN_H
#define MAIN_H

//----------------------------------------------------------------------------

#include <stdint.h>
#include "stm32f10x.h"
#include "gpio.h"
#include "systimer.h"

//------------------   : -----------------------

// 1 (VBAT): +3.3V
// 2 (PC13):    OFF (  - )
// 3 (PC14):    CV (  - )
// 4 (PC15):    CC (  - )
// 5 (PD0):   
// 6 (PD1):   
// 7 (NRST): RESET
// 8 (VSSA): GND
// 9 (VDDA): +3.3VA
//10 (PA0):   
//11 (PA1):   
//12 (PA2/USART2 TX/RX):  OWP  1-Wire 
//13 (PA3):     ON (  - )
//14 (PA4/DAC1 + DMA CH2 + TIM3):   SET_I
//15 (PA5/DAC2 + DMA CH3 + TIM3):   SET_V
//16 (PA6/ADC6 + DMA CH5 + TIM2):   GET_I
//17 (PA7/ADC7 + DMA CH7 + TIM2):   GET_V
//18 (PB0):    SC4 (  - )
//19 (PB1):    SC3 (  - )
//20 (PB2/BOOT1): GND
//21 (PB10):   PVG (  - )
//22 (PB11):    BT_OUT (  - )
//23 (VSS):  GND
//24 (VDD):  +3.3V
//25 (PB12):   SB (  - )
//26 (PB13/TIM1 CH1N):   SND (  - )
//27 (PB14/TIM15 CH1):    FAN (  - )
//28 (PB15):  EF2  (  - )
//29 (PA8):   EF1  (  - )
//30 (PA9/USART1 TXD):   TXD
//31 (PA10/USART1 RXD):   RXD
//32 (PA11):   SC2 (  - )
//33 (PA12):   SC1 (  - )
//34 (PA13/SWDIO): SWDIO
//35 (VSS):  GND
//36 (VDD):  +3.3V
//37 (PA14/SWCL): SWCL
//38 (PA15):  
//39 (PB3/SPI1 SCK):  SCLK  SPI  
//40 (PB4):   
//41 (PB5/SPI1 MOSI):  SDATA  SPI  
//42 (PB6):   LOAD   (  - )
//43 (PB7):   OE   (  - )
//44 (BOOT0): BOOT0
//45 (PB8 + TIM16):  SCL  I2C  EEPROM 24C04
//46 (PB9 + TIM16):  SDA  I2C  EEPROM 24C04
//47 (VSS):  GND
//48 (VDD):  +3.3V

//----------------------------------------------------------------------------

//   Linker->Extra options: --basic_heap

//-------------------------   firmware: ---------------------------

#define VERSION 1.05

//--------------------------- : ------------------------------

#define LO(x)    ((uint8_t)((x) & 0xFF))
#define HI(x)    ((uint8_t)(((x) >> 8) & 0xFF))
#define BYTE1(x) (LO(x))
#define BYTE2(x) (HI(x))
#define BYTE3(x) ((uint8_t)(((uint32_t)(x) >> 16) & 0xFF))
#define BYTE4(x) ((uint8_t)(((uint32_t)(x) >> 24) & 0xFF))

#define WORD(b1,b0)        (((uint16_t)(b1) << 8) | (b0))
#define DWORD(b3,b2,b1,b0) (((uint32_t)WORD(b3,b2) << 16) | WORD(b1,b0))

#define ABS(x) ((x < 0)? -x : x)

#ifndef NULL
  #define NULL _NULL
#endif

//----------------------------------------------------------------------------

#endif
